<?php

/**
 * Magento
 *
 * Override Mage_Checkout_Cart controller
 */
/**
 * IMPORTANT
 * Include the core file to be overridden
 */
require_once("Mage/Checkout/controllers/CartController.php");

/**
 * IMPORTANT
 * Extend the core controller in our custom controller.
 */
class Override_Cart_CartController extends Mage_Checkout_CartController {

    public function ajaxaddAction() {
        $products = explode(',', $this->getRequest()->getParam('products'));
        $customer_points = $this->getRequest()->getParam('customer_points');
        $mother_customer_points = $this->getRequest()->getParam('customer_points');
        $racgp_customer_points = $this->getRequest()->getParam('customer_points');
        $qty=(explode(",",$this->getRequest()->getParam('qty')));
        //echo '<pre>';print_r ($qty);print_r ($products);
        $cart = Mage::getModel('checkout/cart');
        $cart->init();

        
        /* @var $pModel Mage_Catalog_Model_Product */

        foreach ($products as $key=>$product_id) {
            if ($product_id == '')
                continue;

            //$pModel->unsetData();
            $pModel = Mage::getModel('catalog/product');
            $pModel->load($product_id);
            //print_r($pModel);
                       // echo '<br/>';print_r($product_id);
        //if ($pModel->getTypeId() == Mage_Catalog_Model_Product_Type::TYPE_SIMPLE) {
              try {
                   $cart->addProduct($pModel,array('qty' => $qty[$key]) );
             } catch (Exception $e) {
                continue;
              }
            //}
        }
        //die("here");
        $cart->save();
       
        $this->_getSession()->setCartWasUpdated(true);
        // echo '<pre>';print_r($_SESSION);
        $res['msg'] = "success";
        //$customer_points= Mage::getSingleton('checkout/session')->getcurrent_rewardprice();
        //$customer_points=$customer_points-$params['product_points'];
        Mage::getSingleton('checkout/session')->setcurrent_rewardprice($customer_points);
        Mage::getSingleton('checkout/session')->setcurrent_motherrewardprice($mother_customer_points);
        Mage::getSingleton('checkout/session')->setcurrent_racgp_rewardprice($racgp_customer_points);
        Mage::getSingleton('checkout/session')->setSpendRewardPoints('spend_Rewars_used');
        $grandTotal1 = Mage::getModel('checkout/cart')->getQuote()->getGrandTotal();
        $grandTotal = number_format($grandTotal1, 2, '.', '');
        $count = $count = Mage::helper('checkout/cart')->getSummaryCount(); //Mage::getModel('checkout/cart')->getSummaryCount();
        $res['grandtoal'] = $grandTotal;
        $res['count'] = $count;
        echo json_encode($res);
        exit;

        /**

         * @todo remove wishlist observer processAddToCart

         */
        Mage::dispatchEvent('checkout_cart_add_product_complete', array('product' => $product, 'request' => $this->getRequest(), 'response' => $this->getResponse())
        );

        $message = $this->__('%s was successfully added to your shopping cart.', Mage::helper('core')->htmlEscape($product->getName()));

        if (!$this->_getSession()->getNoCartRedirect(true)) {

            $this->_getSession()->addSuccess($message);

            $this->_goBack();
        }
    }
    
     public function addconfigAction() {
       
          $product1   = $this->getRequest()->getParam('product');
          $qty        = $this->getRequest()->getParam('qty');
          $data       = explode(",", $this->getRequest()->getParam('super_attribute'));
         
        // foreach($data as $key=>$pvm){
          // print_r($pvm); 
           if($data != null) {           
                           $params = array(
                                            'product' =>$product1,
                                            'super_attribute' => array(
                                            '548' =>$data['0'] ,
                                            '80' =>$data['1'] ,
                                            
                                        ),
                                        'qty' => $qty,
                                    );    
           
            $cart = Mage::getSingleton('checkout/cart'); 
            $cart->init();
            $product = Mage::getModel('catalog/product');
            
            $product->load($product1); 
            //echo "<pre>";print_r($product);die("here");
            $cart->addProduct($product, $params);
            $cart->save(); 
            Mage::getSingleton('checkout/session')->setCartWasUpdated(true);
          
          }
         
        // }
        $res['msg'] = "success";
        echo json_encode($res);
        exit; 
 }
    
    public function deleteAction()

    {

        $order_id = (int) $this->getRequest()->getParam('id');
       
         $item = Mage::getModel('sales/quote_item')->load($order_id);         
         $id=$item->getProductId();
         $pModel = Mage::getModel('catalog/product');
         $_product=$pModel->load($id);                    
        
          if($pModel['price'] !='0.0000'){
              
             
         $item1=$this->_getCart()->getItems()->getdata(); 
         //echo '<pre>';print_r($item1);die();
        foreach($item1 as $cartdata)
         { 
         if($cartdata['price']=='0.0000')
          {   
               $this->_getCart()->removeItem($cartdata['item_id'])->save();
           }
        }
        
        
        $productprice=0;
        $categoryid='0'.',';
        $productprices=0;
        $websiteid=Mage::app()->getStore()->getWebsiteId();
        $write = Mage::getSingleton('core/resource')->getConnection('core_read');
        $readresult=$write->query("select category_ids from  brst_tipoftheday Where website_id=$websiteid");
        $row = $readresult->fetchAll();
        $category_ids=$row['0']['category_ids'];
        $category_ids_explode=explode(',', $category_ids);

        $session= Mage::getSingleton('checkout/session');
        foreach($session->getQuote()->getAllItems() as $item)
        {
            $category=$item->getProduct()->getCategoryIds();
          // echo  '$categoryid='.$category[0].'<br/>';
           $categoryid .= $category[0].',';
             $result = array_intersect($category, $category_ids_explode);
         //$num=count($category_ids_explode);
       //for($i=0;$i<=$num-1;$i++)
      // {
            if($result)
          {    
            $prices_minus=$pModel['price'];
            $productprice += $item->getPrice()*$item->getQty();
          
         //}
       }   
        }
        
        $grandTotal1 = $productprice;
        $websiteid=Mage::app()->getStore()->getWebsiteId();
        $write = Mage::getSingleton('core/resource')->getConnection('core_read');
        // now $write is an instance of Zend_Db_Adapter_Abstract
        $readresult=$write->query("select currency from  brst_tipoftheday Where website_id=$websiteid");
        $row = $readresult->fetchAll();
        $currency=$row['0']['currency'];
       
        $rewardpoints=$grandTotal1/$currency;
       // echo $rewardpoints.'<br/>';echo $prices_minus;die();
        // $item2=$this->_getCart()->getItems()->getdata();
        
       // $rewardpoints=$rewardpoints-$prices_minus;
       // print_r($pModel['price']);die();
        Mage::getSingleton('checkout/session')->setcurrent_rewardprice($rewardpoints);
        Mage::getSingleton('checkout/session')->setcurrent_motherrewardprice($rewardpoints);
        Mage::getSingleton('checkout/session')->setcurrent_racgp_rewardprice($rewardpoints);
         try {

                $this->_getCart()->removeItem($order_id)

                  ->save();

            } catch (Exception $e) {

                $this->_getSession()->addError($this->__('Cannot remove item'));

            }
        //print_r ($grandTotal1);die('here');
       }else{
           
            
           //$total_points=parseInt($cutomer_points)+ parseInt($cat_points['0']);
           $item1=$this->_getCart()->getItems()->getdata(); 
          // echo '<pre>';print_r($_product['entity_id']);
           foreach ($item1 as $key=>$product_qty)
         {     
               if(($item1[$key]['product_id'])==$_product['entity_id']){
                   
                   $categoryId = $pModel->getCategoryIds($_product['entity_id']);
                   $category = Mage::getModel('catalog/category')->load($categoryId);
                   $cat = $category->getName();
                   $cat_points = explode(" ", $cat);
                   $cutomer_points=Mage::getSingleton('checkout/session')->getcurrent_rewardprice();
                   $item_qty=round($item1[$key]['qty']);
                   $total_cat_points=$item_qty*$cat_points['0'];
                   $total_points=$total_cat_points+$cutomer_points;
                  Mage::getSingleton('checkout/session')->setcurrent_rewardprice($total_points);
                  Mage::getSingleton('checkout/session')->setcurrent_motherrewardprice($total_points);
                  Mage::getSingleton('checkout/session')->setcurrent_racgp_rewardprice($total_points);
               }
         }
         try {

                $this->_getCart()->removeItem($order_id)

                  ->save();

            } catch (Exception $e) {

                $this->_getSession()->addError($this->__('Cannot remove item'));

            }
       }
        
       
        
        
       /* if ($id) {

            try {

                $this->_getCart()->removeItem($id)

                  ->save();

            } catch (Exception $e) {

                $this->_getSession()->addError($this->__('Cannot remove item'));

            }

        }*/

        $this->_redirectReferer(Mage::getUrl('*/*'));

    }
    
     public function updatePostAction()
    {
                
        try {

            $cartData = $this->getRequest()->getParam('cart');

            if (is_array($cartData)) {

                $filter = new Zend_Filter_LocalizedToNormalized(

                    array('locale' => Mage::app()->getLocale()->getLocaleCode())

                );

                foreach ($cartData as $index => $data) {

                    if (isset($data['qty'])) {

                        $cartData[$index]['qty'] = $filter->filter($data['qty']);

                    }

                }

                $cart = $this->_getCart();

                if (! $cart->getCustomerSession()->getCustomer()->getId() && $cart->getQuote()->getCustomerId()) {

                    $cart->getQuote()->setCustomerId(null);

                }

                $cart->updateItems($cartData)

                    ->save();

            }

            $this->_getSession()->setCartWasUpdated(true);

        }

        catch (Mage_Core_Exception $e) {

            $this->_getSession()->addError($e->getMessage());

        }

        catch (Exception $e) {

            $this->_getSession()->addException($e, $this->__('Cannot update shopping cart'));

        }

        $this->_goBack();

    }




}